<?php
namespace FM\Controller;

use FM\Controller\FMCrud;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DataSource\DataSet;
use FM\Service\SolicitacaoService;
use FM\Traits\TResponse;

class SolicitacaoController extends FMCrud {
    
    use TResponse;
    protected $dataSourceName = 'fcm_checklistagend';
    protected $SolicitacaoService;
   
    public function __construct($crudService, $environment, SolicitacaoService $SolicitacaoService) {
        parent::__construct($crudService, $environment);
        $this->SolicitacaoService = $SolicitacaoService;
    }
    
    public function setNewRequest(DTO\Request $request, DTO\Response $response) {
        try{
            $var = $this->SolicitacaoService->setNewRequest($request->getParameters());
            $dtsVal = new DataSet('request', [$var]);
            $response->addDataSet($dtsVal);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getCardsRequests(DTO\Request $request, DTO\Response $response) {
        try {
            $params = $request->getParameters();
            $var = $this->SolicitacaoService->getCardsRequests($params['filter'], $params['usersIds']);
            $dtsVal = new DataSet('cardsRequest', $var);
            $response->addDataSet($dtsVal);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function showRequest(DTO\Request $request, DTO\Response $response) {

       $params = $request->getParameters();
        // debugApi([$params])
       $var = $this->SolicitacaoService->showRequest($params);
       $dtsVal = new DataSet('show', $var);
       $response->addDataSet($dtsVal);
    }

    public function getSituationRequest(DTO\Request $request, DTO\Response $response) {

       $var = $this->SolicitacaoService->getSituationRequest();
       $dtsVal = new DataSet('situation', $var);
       $response->addDataSet($dtsVal);
    }

    public function getNameRequest(DTO\Request $request, DTO\Response $response) {

       $var = $this->SolicitacaoService->getNameRequest();
       $dtsVal = new DataSet('nameRequest', $var);
       $response->addDataSet($dtsVal);
    }

    public function evaluateRequest(DTO\Request $request, DTO\Response $response) {

        try {
            $var = $this->SolicitacaoService->evaluateRequest($request->getParameters());
            $dtsVal = new DataSet('evaluate', [$var]);
            $response->addDataSet($dtsVal);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

    public function getLocalRequest(DTO\Request $request, DTO\Response $response) {
        try {
            $var = $this->SolicitacaoService->getLocalRequest($request->getParameters());
            $dtsVal = new DataSet('local', $var);
            $response->addDataSet($dtsVal);
        } catch (Exception $ex) {
            $this->sendResponse(['error' => $ex->getMessage(), 'code' => $ex->getCode()], 500);
        }
    }

}
?>